//
//  NSBezierPath+IOS7RoundedRect.m
//
//  Created by Matej Dunik on 11/12/13.
//  Copyright (c) 2013 PixelCut. All rights reserved except as below:
//  This code is provided as-is, without warranty of any kind. You may use it in your projects as you wish.
//

#import "NSBezierPath+IOS7RoundedRect.h"

@implementation NSBezierPath (IOS7RoundedRect)

#define TOP_LEFT(X, Y) NSMakePoint(rect.origin.x + X * limitedCornerRadius, rect.origin.y + Y * limitedCornerRadius)
#define TOP_RIGHT(X, Y) NSMakePoint(rect.origin.x + rect.size.width - X * limitedCornerRadius, rect.origin.y + Y * limitedCornerRadius)
#define BOTTOM_RIGHT(X, Y) NSMakePoint(rect.origin.x + rect.size.width - X * limitedCornerRadius, rect.origin.y + rect.size.height - Y * limitedCornerRadius)
#define BOTTOM_LEFT(X, Y) NSMakePoint(rect.origin.x + X * limitedCornerRadius, rect.origin.y + rect.size.height - Y * limitedCornerRadius)

#define TOP(Y) NSMakePoint(NSMidX(rect), rect.origin.y + Y * rect.size.width)
#define BOTTOM(Y) NSMakePoint(NSMidX(rect), rect.origin.y + rect.size.height - Y * limitedCornerRadius)
#define LEFT(X) NSMakePoint(rect.origin.x + X * rect.size.height, NSMidY(rect))
#define RIGHT(X) NSMakePoint(rect.origin.x + rect.size.width - X * limitedCornerRadius, NSMidY(rect))

- (void)addIOS7RoundedRect1: (NSRect)rect cornerRadius: (CGFloat)cornerRadius;
{
    CGFloat limitedCornerRadius = MIN(cornerRadius, MIN(rect.size.width, rect.size.height) / 2 / 1.52866483);
    
    [self moveToPoint: TOP_LEFT(1.52866483, 0.00000000)];
    [self lineToPoint: TOP_RIGHT(1.52866471, 0.00000000)];
    [self curveToPoint: TOP_RIGHT(0.66993427, 0.06549600) controlPoint1: TOP_RIGHT(1.08849323, 0.00000000) controlPoint2: TOP_RIGHT(0.86840689, 0.00000000)];
    [self lineToPoint: TOP_RIGHT(0.63149399, 0.07491100)];
    [self curveToPoint: TOP_RIGHT(0.07491176, 0.63149399) controlPoint1: TOP_RIGHT(0.37282392, 0.16905899) controlPoint2: TOP_RIGHT(0.16906013, 0.37282401)];
    [self curveToPoint: TOP_RIGHT(0.00000000, 1.52866483) controlPoint1: TOP_RIGHT(0.00000000, 0.86840701) controlPoint2: TOP_RIGHT(0.00000000, 1.08849299)];
    [self lineToPoint: BOTTOM_RIGHT(0.00000000, 1.52866471)];
    [self curveToPoint: BOTTOM_RIGHT(0.06549569, 0.66993493) controlPoint1: BOTTOM_RIGHT(0.00000000, 1.08849323) controlPoint2: BOTTOM_RIGHT(0.00000000, 0.86840689)];
    [self lineToPoint: BOTTOM_RIGHT(0.07491111, 0.63149399)];
    [self curveToPoint: BOTTOM_RIGHT(0.63149399, 0.07491111) controlPoint1: BOTTOM_RIGHT(0.16905883, 0.37282392) controlPoint2: BOTTOM_RIGHT(0.37282392, 0.16905883)];
    [self curveToPoint: BOTTOM_RIGHT(1.52866471, 0.00000000) controlPoint1: BOTTOM_RIGHT(0.86840689, 0.00000000) controlPoint2: BOTTOM_RIGHT(1.08849323, 0.00000000)];
    [self lineToPoint: BOTTOM_LEFT(1.52866483, 0.00000000)];
    [self curveToPoint: BOTTOM_LEFT(0.66993397, 0.06549569) controlPoint1: BOTTOM_LEFT(1.08849299, 0.00000000) controlPoint2: BOTTOM_LEFT(0.86840701, 0.00000000)];
    [self lineToPoint: BOTTOM_LEFT(0.63149399, 0.07491111)];
    [self curveToPoint: BOTTOM_LEFT(0.07491100, 0.63149399) controlPoint1: BOTTOM_LEFT(0.37282401, 0.16905883) controlPoint2: BOTTOM_LEFT(0.16906001, 0.37282392)];
    [self curveToPoint: BOTTOM_LEFT(0.00000000, 1.52866471) controlPoint1: BOTTOM_LEFT(0.00000000, 0.86840689) controlPoint2: BOTTOM_LEFT(0.00000000, 1.08849323)];
    [self lineToPoint: TOP_LEFT(0.00000000, 1.52866483)];
    [self curveToPoint: TOP_LEFT(0.06549600, 0.66993397) controlPoint1: TOP_LEFT(0.00000000, 1.08849299) controlPoint2: TOP_LEFT(0.00000000, 0.86840701)];
    [self lineToPoint: TOP_LEFT(0.07491100, 0.63149399)];
    [self curveToPoint: TOP_LEFT(0.63149399, 0.07491100) controlPoint1: TOP_LEFT(0.16906001, 0.37282401) controlPoint2: TOP_LEFT(0.37282401, 0.16906001)];
    [self curveToPoint: TOP_LEFT(1.52866483, 0.00000000) controlPoint1: TOP_LEFT(0.86840701, 0.00000000) controlPoint2: TOP_LEFT(1.08849299, 0.00000000)];
    [self closePath];
}


- (void)addIOS7RoundedRect2a: (NSRect)rect cornerRadius: (CGFloat)cornerRadius;
{
    CGFloat limitedCornerRadius = MIN(cornerRadius, MIN(rect.size.width, rect.size.height) / 2 / 1.52866483);

    [self moveToPoint: TOP_LEFT(2.00593972, 0.00000000)];
    [self lineToPoint: NSMakePoint(rect.origin.x + rect.size.width - 1.52866483 * cornerRadius, rect.origin.y + 0 * cornerRadius)];
    [self curveToPoint: TOP_RIGHT(0.99544263, 0.10012127) controlPoint1: TOP_RIGHT(1.63527834, 0.00000000) controlPoint2: TOP_RIGHT(1.29884040, 0.00000000)];
    [self lineToPoint: TOP_RIGHT(0.93667978, 0.11451437)];
    [self curveToPoint: TOP_RIGHT(0.00000051, 1.45223188) controlPoint1: TOP_RIGHT(0.37430558, 0.31920183) controlPoint2: TOP_RIGHT(0.00000051, 0.85376567)];
    [self curveToPoint: RIGHT(0.00000000) controlPoint1: RIGHT(0.00000000) controlPoint2: RIGHT(0.00000000)];
    [self lineToPoint: RIGHT(0.00000000)];
    [self curveToPoint: RIGHT(0.00000000) controlPoint1: RIGHT(0.00000000) controlPoint2: RIGHT(0.00000000)];
    [self lineToPoint: BOTTOM_RIGHT(0.00000000, 1.45223165)];
    [self curveToPoint: BOTTOM_RIGHT(0.93667978, 0.11451438) controlPoint1: BOTTOM_RIGHT(0.00000000, 0.85376561) controlPoint2: BOTTOM_RIGHT(0.37430558, 0.31920174)];
    [self curveToPoint: BOTTOM_RIGHT(2.30815363, 0.00000000) controlPoint1: BOTTOM_RIGHT(1.29884040, 0.00000000) controlPoint2: BOTTOM_RIGHT(1.63527834, 0.00000000)];
    [self lineToPoint: NSMakePoint(rect.origin.x + 1.52866483 * cornerRadius, rect.origin.y + rect.size.height - 0 * limitedCornerRadius)];
    [self curveToPoint: BOTTOM_LEFT(0.99544257, 0.10012124) controlPoint1: BOTTOM_LEFT(1.63527822, 0.00000000) controlPoint2: BOTTOM_LEFT(1.29884040, 0.00000000)];
    [self lineToPoint: BOTTOM_LEFT(0.93667972, 0.11451438)];
    [self curveToPoint: BOTTOM_LEFT(-0.00000001, 1.45223176) controlPoint1: BOTTOM_LEFT(0.37430549, 0.31920174) controlPoint2: BOTTOM_LEFT(-0.00000007, 0.85376561)];
    [self curveToPoint: LEFT(0.00000000) controlPoint1: LEFT(0.00000000) controlPoint2: LEFT(0.00000000)];
    [self lineToPoint: LEFT(0.00000000)];
    [self curveToPoint: LEFT(0.00000000) controlPoint1: LEFT(0.00000000) controlPoint2: LEFT(0.00000000)];
    [self lineToPoint: TOP_LEFT(-0.00000001, 1.45223153)];
    [self curveToPoint: TOP_LEFT(0.93667978, 0.11451436) controlPoint1: TOP_LEFT(0.00000004, 0.85376537) controlPoint2: TOP_LEFT(0.37430561, 0.31920177)];
    [self curveToPoint: TOP_LEFT(2.30815363, 0.00000000) controlPoint1: TOP_LEFT(1.29884040, 0.00000000) controlPoint2: TOP_LEFT(1.63527822, 0.00000000)];
    [self lineToPoint: NSMakePoint(rect.origin.x + 1.52866483 * cornerRadius, rect.origin.y + 0 * cornerRadius)];
    [self lineToPoint: TOP_LEFT(2.00593972, 0.00000000)];
    [self closePath];
}


- (void)addIOS7RoundedRect2b: (NSRect)rect cornerRadius: (CGFloat)cornerRadius;
{
    CGFloat limitedCornerRadius = MIN(cornerRadius, MIN(rect.size.width, rect.size.height) / 2 / 1.52866483);
    
    [self moveToPoint: TOP(0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self curveToPoint: TOP(0.00000000) controlPoint1: TOP(0.00000000) controlPoint2: TOP(0.00000000)];
    [self lineToPoint: TOP_RIGHT(1.45223153, 0.00000000)];
    [self curveToPoint: TOP_RIGHT(0.11451442, 0.93667936) controlPoint1: TOP_RIGHT(0.85376573, 0.00000001) controlPoint2: TOP_RIGHT(0.31920189, 0.37430537)];
    [self curveToPoint: TOP_RIGHT(0.00000000, 2.30815387) controlPoint1: TOP_RIGHT(0.00000000, 1.29884040) controlPoint2: TOP_RIGHT(0.00000000, 1.63527822)];
    [self lineToPoint: NSMakePoint(rect.origin.x + rect.size.width - 0 * cornerRadius, rect.origin.y + rect.size.height - 1.52866483 * cornerRadius)];
    [self curveToPoint: BOTTOM_RIGHT(0.10012137, 0.99544269) controlPoint1: BOTTOM_RIGHT(0.00000000, 1.63527822) controlPoint2: BOTTOM_RIGHT(0.00000000, 1.29884028)];
    [self lineToPoint: BOTTOM_RIGHT(0.11451442, 0.93667972)];
    [self curveToPoint: BOTTOM_RIGHT(1.45223165, 0.00000000) controlPoint1: BOTTOM_RIGHT(0.31920189, 0.37430552) controlPoint2: BOTTOM_RIGHT(0.85376549, 0.00000000)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM(0.00000000) controlPoint2: BOTTOM(0.00000000)];
    [self lineToPoint: BOTTOM(0.00000000)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM(0.00000000) controlPoint2: BOTTOM(0.00000000)];
    [self lineToPoint: BOTTOM_LEFT(1.45223141, 0.00000000)];
    [self curveToPoint: BOTTOM_LEFT(0.11451446, 0.93667972) controlPoint1: BOTTOM_LEFT(0.85376543, 0.00000000) controlPoint2: BOTTOM_LEFT(0.31920192, 0.37430552)];
    [self curveToPoint: BOTTOM_LEFT(0.00000000, 2.30815387) controlPoint1: BOTTOM_LEFT(0.00000000, 1.29884028) controlPoint2: BOTTOM_LEFT(0.00000000, 1.63527822)];
    [self lineToPoint: NSMakePoint(rect.origin.x + 0 * cornerRadius, rect.origin.y + 1.52866483 * cornerRadius)];
    [self curveToPoint: TOP_LEFT(0.10012126, 0.99544257) controlPoint1: TOP_LEFT(0.00000000, 1.63527822) controlPoint2: TOP_LEFT(0.00000000, 1.29884040)];
    [self lineToPoint: TOP_LEFT(0.11451443, 0.93667966)];
    [self curveToPoint: TOP_LEFT(1.45223153, 0.00000000) controlPoint1: TOP_LEFT(0.31920189, 0.37430552) controlPoint2: TOP_LEFT(0.85376549, 0.00000000)];
    [self curveToPoint: TOP(0.00000000) controlPoint1: TOP(0.00000000) controlPoint2: TOP(0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self closePath];
}


- (void)addIOS7RoundedRect3: (NSRect)rect cornerRadius: (CGFloat)cornerRadius;
{
    CGFloat limitedCornerRadius = MIN(cornerRadius, MIN(rect.size.width, rect.size.height) / 2 / 1.52866483);
    
    [self moveToPoint: TOP(0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self curveToPoint: TOP(0.00000000) controlPoint1: TOP(0.00000000) controlPoint2: TOP(0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self curveToPoint: TOP_RIGHT(0.00000000, 1.52866483) controlPoint1: TOP_RIGHT(0.68440646, 0.00000001) controlPoint2: TOP_RIGHT(0.00000000, 0.68440658)];
    [self curveToPoint: TOP_RIGHT(0.00000000, 1.52866507) controlPoint1: TOP_RIGHT(0.00000000, 1.52866495) controlPoint2: TOP_RIGHT(0.00000000, 1.52866495)];
    [self curveToPoint: TOP_RIGHT(0.00000000, 1.52866483) controlPoint1: TOP_RIGHT(0.00000000, 1.52866483) controlPoint2: TOP_RIGHT(0.00000000, 1.52866483)];
    [self lineToPoint: RIGHT(0.00000000)];
    [self curveToPoint: BOTTOM_RIGHT(0.00000000, 1.52866471) controlPoint1: BOTTOM_RIGHT(0.00000000, 1.52866471) controlPoint2: BOTTOM_RIGHT(0.00000000, 1.52866471)];
    [self lineToPoint: BOTTOM_RIGHT(0.00000000, 1.52866471)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM_RIGHT(0.00000000, 0.68440646) controlPoint2: BOTTOM_RIGHT(0.68440646, 0.00000000)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM(0.00000000) controlPoint2: BOTTOM(0.00000000)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM(0.00000000) controlPoint2: BOTTOM(0.00000000)];
    [self lineToPoint: BOTTOM(0.00000000)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM(0.00000000) controlPoint2: BOTTOM(0.00000000)];
    [self lineToPoint: BOTTOM(0.00000000)];
    [self curveToPoint: BOTTOM_LEFT(0.00000000, 1.52866471) controlPoint1: BOTTOM_LEFT(0.68440646, 0.00000000) controlPoint2: BOTTOM_LEFT(-0.00000004, 0.68440646)];
    [self curveToPoint: BOTTOM_LEFT(0.00000000, 1.52866495) controlPoint1: BOTTOM_LEFT(0.00000000, 1.52866471) controlPoint2: BOTTOM_LEFT(0.00000000, 1.52866495)];
    [self curveToPoint: BOTTOM_LEFT(0.00000000, 1.52866471) controlPoint1: BOTTOM_LEFT(0.00000000, 1.52866471) controlPoint2: BOTTOM_LEFT(0.00000000, 1.52866471)];
    [self lineToPoint: LEFT(0.00000000)];
    [self curveToPoint: TOP_LEFT(0.00000000, 1.52866483) controlPoint1: TOP_LEFT(0.00000000, 1.52866483) controlPoint2: TOP_LEFT(0.00000000, 1.52866483)];
    [self lineToPoint: TOP_LEFT(0.00000000, 1.52866471)];
    [self curveToPoint: TOP(0.00000000) controlPoint1: TOP_LEFT(0.00000007, 0.68440652) controlPoint2: TOP_LEFT(0.68440658, -0.00000001)];
    [self curveToPoint: TOP(0.00000000) controlPoint1: TOP(0.00000000) controlPoint2: TOP(0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self closePath];
}


- (void)addIOS7RoundedRect3a: (NSRect)rect cornerRadius: (CGFloat)cornerRadius;
{
    CGFloat limitedCornerRadius = MIN(cornerRadius, MIN(rect.size.width, rect.size.height) / 2 / 1.52866483);

    [self moveToPoint: TOP(0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self curveToPoint: TOP(0.00000000) controlPoint1: TOP(0.00000000) controlPoint2: TOP(0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self curveToPoint: TOP_RIGHT(0.00000000, 1.52866483) controlPoint1: TOP_RIGHT(0.68440646, 0.00000001) controlPoint2: TOP_RIGHT(0.00000000, 0.68440658)];
    [self curveToPoint: TOP_RIGHT(0.00000000, 1.52866507) controlPoint1: TOP_RIGHT(0.00000000, 1.52866495) controlPoint2: TOP_RIGHT(0.00000000, 1.52866495)];
    [self curveToPoint: TOP_RIGHT(0.00000000, 1.52866483) controlPoint1: TOP_RIGHT(0.00000000, 1.52866483) controlPoint2: TOP_RIGHT(0.00000000, 1.52866483)];
    [self lineToPoint: RIGHT(0.00000000)];
    [self curveToPoint: BOTTOM_RIGHT(0.00000000, 1.52866471) controlPoint1: BOTTOM_RIGHT(0.00000000, 1.52866471) controlPoint2: BOTTOM_RIGHT(0.00000000, 1.52866471)];
    [self lineToPoint: BOTTOM_RIGHT(0.00000000, 1.52866471)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM_RIGHT(0.00000000, 0.68440646) controlPoint2: BOTTOM_RIGHT(0.68440646, 0.00000000)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM(0.00000000) controlPoint2: BOTTOM(0.00000000)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM(0.00000000) controlPoint2: BOTTOM(0.00000000)];
    [self lineToPoint: BOTTOM(0.00000000)];
    [self curveToPoint: BOTTOM(0.00000000) controlPoint1: BOTTOM(0.00000000) controlPoint2: BOTTOM(0.00000000)];
    [self lineToPoint: BOTTOM(0.00000000)];
    [self curveToPoint: BOTTOM_LEFT(0.00000000, 1.52866471) controlPoint1: BOTTOM_LEFT(0.68440646, 0.00000000) controlPoint2: BOTTOM_LEFT(-0.00000004, 0.68440646)];
    [self curveToPoint: BOTTOM_LEFT(0.00000000, 1.52866495) controlPoint1: BOTTOM_LEFT(0.00000000, 1.52866471) controlPoint2: BOTTOM_LEFT(0.00000000, 1.52866495)];
    [self curveToPoint: BOTTOM_LEFT(0.00000000, 1.52866471) controlPoint1: BOTTOM_LEFT(0.00000000, 1.52866471) controlPoint2: BOTTOM_LEFT(0.00000000, 1.52866471)];
    [self lineToPoint: LEFT(0.00000000)];
    [self curveToPoint: TOP_LEFT(0.00000000, 1.52866483) controlPoint1: TOP_LEFT(0.00000000, 1.52866483) controlPoint2: TOP_LEFT(0.00000000, 1.52866483)];
    [self lineToPoint: TOP_LEFT(0.00000000, 1.52866471)];
    [self curveToPoint: TOP(0.00000000) controlPoint1: TOP_LEFT(0.00000007, 0.68440652) controlPoint2: TOP_LEFT(0.68440658, -0.00000001)];
    [self curveToPoint: TOP(0.00000000) controlPoint1: TOP(0.00000000) controlPoint2: TOP(0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self closePath];
}


- (void)addIOS7RoundedRect3b: (NSRect)rect cornerRadius: (CGFloat)cornerRadius;
{
    CGFloat limitedCornerRadius = MIN(cornerRadius, MIN(rect.size.width, rect.size.height) / 2 / 1.52866483);

    [self moveToPoint: TOP(0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self curveToPoint: TOP_RIGHT(1.52866495, 0.00000000) controlPoint1: TOP_RIGHT(1.52866495, 0.00000000) controlPoint2: TOP_RIGHT(1.52866495, 0.00000000)];
    [self lineToPoint: TOP_RIGHT(1.52866495, 0.00000000)];
    [self curveToPoint: RIGHT(0.00000000) controlPoint1: TOP_RIGHT(0.68440676, 0.00000001) controlPoint2: TOP_RIGHT(0.00000000, 0.68440658)];
    [self curveToPoint: RIGHT(0.00000000) controlPoint1: RIGHT(0.00000000) controlPoint2: RIGHT(0.00000000)];
    [self curveToPoint: RIGHT(0.00000000) controlPoint1: RIGHT(0.00000000) controlPoint2: RIGHT(0.00000000)];
    [self lineToPoint: RIGHT(0.00000000)];
    [self curveToPoint: RIGHT(0.00000000) controlPoint1: RIGHT(0.00000000) controlPoint2: RIGHT(0.00000000)];
    [self lineToPoint: RIGHT(0.00000000)];
    [self curveToPoint: BOTTOM_RIGHT(1.52866495, 0.00000000) controlPoint1: BOTTOM_RIGHT(0.00000000, 0.68440652) controlPoint2: BOTTOM_RIGHT(0.68440676, 0.00000000)];
    [self curveToPoint: BOTTOM_RIGHT(1.52866495, 0.00000000) controlPoint1: BOTTOM_RIGHT(1.52866495, 0.00000000) controlPoint2: BOTTOM_RIGHT(1.52866495, 0.00000000)];
    [self curveToPoint: BOTTOM_RIGHT(1.52866495, 0.00000000) controlPoint1: BOTTOM_RIGHT(1.52866495, 0.00000000) controlPoint2: BOTTOM_RIGHT(1.52866495, 0.00000000)];
    [self lineToPoint: BOTTOM(0.00000000)];
    [self curveToPoint: BOTTOM_LEFT(1.52866483, 0.00000000) controlPoint1: BOTTOM_LEFT(1.52866483, 0.00000000) controlPoint2: BOTTOM_LEFT(1.52866483, 0.00000000)];
    [self lineToPoint: BOTTOM_LEFT(1.52866471, 0.00000000)];
    [self curveToPoint: LEFT(0.00000000) controlPoint1: BOTTOM_LEFT(0.68440646, 0.00000000) controlPoint2: BOTTOM_LEFT(-0.00000004, 0.68440676)];
    [self curveToPoint: LEFT(0.00000000) controlPoint1: LEFT(0.00000000) controlPoint2: LEFT(0.00000000)];
    [self curveToPoint: LEFT(0.00000000) controlPoint1: LEFT(0.00000000) controlPoint2: LEFT(0.00000000)];
    [self lineToPoint: LEFT(0.00000000)];
    [self curveToPoint: LEFT(0.00000000) controlPoint1: LEFT(0.00000000) controlPoint2: LEFT(0.00000000)];
    [self lineToPoint: LEFT(0.00000000)];
    [self curveToPoint: TOP_LEFT(1.52866483, 0.00000000) controlPoint1: TOP_LEFT(0.00000007, 0.68440652) controlPoint2: TOP_LEFT(0.68440664, -0.00000001)];
    [self curveToPoint: TOP_LEFT(1.52866483, 0.00000000) controlPoint1: TOP_LEFT(1.52866483, 0.00000000) controlPoint2: TOP_LEFT(1.52866483, 0.00000000)];
    [self lineToPoint: TOP(0.00000000)];
    [self closePath];
}


+ (NSBezierPath*)bezierPathWithIOS7RoundedRect: (NSRect)rect cornerRadius: (CGFloat)radius;
{
    NSBezierPath* path = NSBezierPath.bezierPath;
    
    if (rect.size.width > 1.52866495 * 2 * radius
        && rect.size.height > 1.52866495 * 2 * radius)
        [path addIOS7RoundedRect1: rect cornerRadius: radius];
    
    else if (rect.size.width > 1.52866495 * 2 * radius)
        [path addIOS7RoundedRect2a: rect cornerRadius: radius];
    
    else if (rect.size.height > 1.52866495 * 2 * radius)
        [path addIOS7RoundedRect2b: rect cornerRadius: radius];
    
    else if (rect.size.height > rect.size.width)
        [path addIOS7RoundedRect3a: rect cornerRadius: radius];
    
    else
        [path addIOS7RoundedRect3b: rect cornerRadius: radius];
    
    return path;
}


@end
